/*
 * NotesDialog.java
 *
 * Created on September 3, 2008, 4:53 PM
 */

package jdbernard.timestamper.gui;

import java.awt.Font;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionListener;
import javax.swing.JDialog;

/**
 *
 * @author  jbernard
 */
public class NotesDialog extends JDialog implements MouseMotionListener {

    /** Creates new form NotesDialog */
    public NotesDialog(TimeStamperView parent, boolean modal) {
        super(parent.getFrame(), modal);
        initComponents();

        setSize(325, 200);
        thinNotesFont = notesTextArea.getFont().deriveFont(Font.PLAIN);
        boldNotesFont = notesTextArea.getFont().deriveFont(Font.BOLD);

        setLocationRelativeTo(parent.getFrame());
        this.parent = parent;
    }

    public void setNotes(String notes) {
        notesTextArea.setText(notes);
        notesTextArea.setFont(boldNotesFont);
    }

    public String getNotes() {
        return notesTextArea.getText();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        mainPanel = new javax.swing.JPanel();
        notesScollPane = new javax.swing.JScrollPane();
        notesTextArea = new javax.swing.JTextArea();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setName("Form"); // NOI18N
        setUndecorated(true);

        mainPanel.setBorder(javax.swing.BorderFactory.createMatteBorder(2, 2, 2, 2, new java.awt.Color(0, 0, 0)));
        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(jdbernard.timestamper.gui.TimeStamperApp.class).getContext().getResourceMap(NotesDialog.class);
        mainPanel.setToolTipText(resourceMap.getString("mainPanel.toolTipText")); // NOI18N
        mainPanel.setName("mainPanel"); // NOI18N
        mainPanel.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                mainPanelMousePressed(evt);
            }
        });
        mainPanel.addMouseMotionListener(this);

        notesScollPane.setName("notesScollPane"); // NOI18N

        notesTextArea.setColumns(20);
        notesTextArea.setFont(notesTextArea.getFont().deriveFont((notesTextArea.getFont().getStyle() & ~java.awt.Font.ITALIC) & ~java.awt.Font.BOLD, notesTextArea.getFont().getSize()-2));
        notesTextArea.setLineWrap(true);
        notesTextArea.setRows(5);
        notesTextArea.setWrapStyleWord(true);
        notesTextArea.setName("notesTextArea"); // NOI18N
        notesTextArea.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                notesTextAreaKeyReleased(evt);
            }
        });
        notesScollPane.setViewportView(notesTextArea);

        javax.swing.GroupLayout mainPanelLayout = new javax.swing.GroupLayout(mainPanel);
        mainPanel.setLayout(mainPanelLayout);
        mainPanelLayout.setHorizontalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(mainPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(notesScollPane, javax.swing.GroupLayout.DEFAULT_SIZE, 258, Short.MAX_VALUE)
                .addContainerGap())
        );
        mainPanelLayout.setVerticalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, mainPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(notesScollPane, javax.swing.GroupLayout.DEFAULT_SIZE, 174, Short.MAX_VALUE)
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(mainPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(mainPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void notesTextAreaKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_notesTextAreaKeyReleased
    if ((evt.getKeyCode() == KeyEvent.VK_ENTER) && evt.isControlDown()) {
        parent.setNotesForActiveTask(notesTextArea.getText());
        notesTextArea.setFont(boldNotesFont);
    } else if (evt.getKeyCode() != KeyEvent.VK_CONTROL)
        notesTextArea.setFont(thinNotesFont);
}//GEN-LAST:event_notesTextAreaKeyReleased

private void mainPanelMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_mainPanelMousePressed
    mousePressRelativeToWindow = evt.getPoint();
}//GEN-LAST:event_mainPanelMousePressed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel mainPanel;
    private javax.swing.JScrollPane notesScollPane;
    private javax.swing.JTextArea notesTextArea;
    // End of variables declaration//GEN-END:variables

    private TimeStamperView parent;
    Font thinNotesFont;
    Font boldNotesFont;
    Point mousePressRelativeToWindow;

    public void mouseDragged(MouseEvent e) {
        setLocation(TimeStamperView.calculateWindowMovement(
                e.getLocationOnScreen(), mousePressRelativeToWindow,
                getBounds(), parent.getFrame().getBounds(),
                new Rectangle(Toolkit.getDefaultToolkit().getScreenSize())));
    }

    public void mouseMoved(MouseEvent e) {
    }
}
